PTLib Version 2.12.9

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
XMPP::MUC::Room Class Reference

`#include <xmpp_muc.h>`

Inheritance diagram for XMPP::MUC::Room:
[legend]
Collaboration diagram for XMPP::MUC::Room:
[legend]

## Public Member Functions
| Room (C2S::StreamHandler *handler, const JID &jid, const PString &nick)
| Our user in the room. More...
const User & | GetUser () const
const Users & | GetOtherUsers () const
virtual PBoolean | Enter ()
virtual PBoolean | Leave ()
virtual PBoolean | SendMessage (const PString &msg)
virtual PBoolean | SendMessage (Message &msg)
virtual void | OnMessage (Message &msg)
virtual void | OnRoomJoined ()
virtual void | OnRoomLeft ()
virtual void | OnUserAdded (User &user)
virtual void | OnUserRemoved (User &user)
virtual void | OnUserChanged (User &user)
Public Member Functions inherited from PObject
unsigned | GetTraceContextIdentifier () const
| Get PTRACE context identifier. More...
void | SetTraceContextIdentifier (unsigned id)
void | GetTraceContextIdentifier (PObject &obj)
void | GetTraceContextIdentifier (PObject *obj)
void | SetTraceContextIdentifier (const PObject &obj)
void | SetTraceContextIdentifier (const PObject *obj)
virtual | ~PObject ()
virtual PObject * | Clone () const
| Create a copy of the class on the heap. More...
template<class CLS >
CLS * | CloneAs () const
| As for Clone() but converts to specified type. More...
virtual PINDEX | HashFunction () const
| This function yields a hash value required by the `PDictionary` class. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
__inline const PObject * | PTraceObjectInstance () const
virtual Comparison | Compare (const PObject &obj) const
| Compare the two objects and return their relative rank. More...
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...
virtual void | PrintOn (ostream &strm) const
| Output the contents of the object to the stream. More...
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...
Public Member Functions inherited from PValidatedNotifierTarget
| PValidatedNotifierTarget ()
virtual | ~PValidatedNotifierTarget ()
| PValidatedNotifierTarget (const PValidatedNotifierTarget &)
void | operator= (const PValidatedNotifierTarget &)

## Protected Member Functions
| PDECLARE_VALIDATED_NOTIFIER (C2S::StreamHandler, Room, OnSessionReleased)
| PDECLARE_VALIDATED_NOTIFIER (Message, Room, OnMessage)
| PDECLARE_VALIDATED_NOTIFIER (Presence, Room, OnPresence)
Protected Member Functions inherited from PObject
| PObject ()
| Constructor for PObject, made protected so cannot ever create one on its own. More...

## Protected Attributes
C2S::StreamHandler * | m_Handler
BareJID | m_RoomJID
User | m_User
Users | m_OtherUsers
PNotifierList | m_MessageHandlers
PNotifierList | m_RoomJoinedHandlers
PNotifierList | m_RoomLeftHandlers
PNotifierList | m_UserAddedHandlers
PNotifierList | m_UserRemovedHandlers
PNotifierList | m_UserChangedHandlers
Protected Attributes inherited from PObject
unsigned | m_traceContextIdentifier

## Additional Inherited Members
Public Types inherited from PObject
enum | Comparison { LessThan = -1, EqualTo = 0, GreaterThan = 1 }
| Result of the comparison operation performed by the `Compare()` function. More...
Static Public Member Functions inherited from PObject
static const char * | Class ()
| Get the name of the class as a C string. More...
static __inline const PObject * | PTraceObjectInstance (const char *)
static __inline const PObject * | PTraceObjectInstance (const PObject *obj)
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...
Static Public Member Functions inherited from PValidatedNotifierTarget
static bool | Exists (PNotifierIdentifer id)
Friends inherited from PObject

## Constructor & Destructor Documentation

XMPP::MUC::Room::Room | ( | C2S::StreamHandler * | handler,
|  | const JID & | jid,
|  | const PString & | nick
| ) |  |

Our user in the room.

Parameters

  handler | The C2S stream handler
  jid | The room's jid

## Member Function Documentation

virtual PBoolean XMPP::MUC::Room::Enter | ( |  | ) |
| virtual

const Users& XMPP::MUC::Room::GetOtherUsers | ( |  | ) | const
| inline

References m_OtherUsers.

const User& XMPP::MUC::Room::GetUser | ( |  | ) | const
| inline

References m_User.

virtual PBoolean XMPP::MUC::Room::Leave | ( |  | ) |
| virtual

virtual void XMPP::MUC::Room::OnMessage | ( | Message & | msg | ) |
| virtual

virtual void XMPP::MUC::Room::OnRoomJoined | ( |  | ) |
| virtual

virtual void XMPP::MUC::Room::OnRoomLeft | ( |  | ) |
| virtual

virtual void XMPP::MUC::Room::OnUserAdded | ( | User & | user | ) |
| virtual

virtual void XMPP::MUC::Room::OnUserChanged | ( | User & | user | ) |
| virtual

virtual void XMPP::MUC::Room::OnUserRemoved | ( | User & | user | ) |
| virtual

XMPP::MUC::Room::PDECLARE_VALIDATED_NOTIFIER | ( | C2S::StreamHandler | ,
|  | Room | ,
|  | OnSessionReleased |
| ) |  |
| protected

XMPP::MUC::Room::PDECLARE_VALIDATED_NOTIFIER | ( | Message | ,
|  | Room | ,
|  | OnMessage |
| ) |  |
| protected

XMPP::MUC::Room::PDECLARE_VALIDATED_NOTIFIER | ( | Presence | ,
|  | Room | ,
|  | OnPresence |
| ) |  |
| protected

virtual PBoolean XMPP::MUC::Room::SendMessage | ( | const PString & | msg | ) |
| virtual

virtual PBoolean XMPP::MUC::Room::SendMessage | ( | Message & | msg | ) |
| virtual

## Member Data Documentation

C2S::StreamHandler* XMPP::MUC::Room::m_Handler
| protected

PNotifierList XMPP::MUC::Room::m_MessageHandlers
| protected

Users XMPP::MUC::Room::m_OtherUsers
| protected

Referenced by GetOtherUsers().

BareJID XMPP::MUC::Room::m_RoomJID
| protected

PNotifierList XMPP::MUC::Room::m_RoomJoinedHandlers
| protected

PNotifierList XMPP::MUC::Room::m_RoomLeftHandlers
| protected

User XMPP::MUC::Room::m_User
| protected

Referenced by GetUser().

PNotifierList XMPP::MUC::Room::m_UserAddedHandlers
| protected

PNotifierList XMPP::MUC::Room::m_UserChangedHandlers
| protected

PNotifierList XMPP::MUC::Room::m_UserRemovedHandlers
| protected

The documentation for this class was generated from the following file:

- xmpp_muc.h